algebra-3.1: Constructive abstract algebra

Safe Haskell | None

Numeric.Semiring.Integral

Synopsis

- class (Monoidal r, Semiring r) => IntegralSemiring r

# Documentation

class (Monoidal r, Semiring r) => IntegralSemiring r Source

An integral semiring has no zero divisors

     a * b = 0 implies a == 0 || b == 0

Instances

IntegralSemiring Bool |
IntegralSemiring Integer |
IntegralSemiring Natural |